<template>
  <div class="bargainList pagePadding">
    <div>
      <ex-table
        v-loading="loading"
        :table="table"
        :data="tableData"
        :columns="columns"
        :page="pageInfo"
        :size="size"
        @page-curr-change="handlePageChange"
        @page-size-change="handleSizeChange"
        @selection-change="handleSelection"
        @screen-reset="
          pageInfo.curr = 1;
          parmValue.page = 1;
          searchList();
        "
        @screen-submit="
          pageInfo.curr = 1;
          parmValue.page = 1;
          searchList();
        "
      >
        <template #table-header="{}">
          <div style="width: 100%">
            <el-row style="padding: 0 0 0 80px">
              <el-col :span="4" style="width: 301px; padding: 0 0 0 0px">
                <period-date-picker
                  :start="parmValue[mapFields.createStart]"
                  :end="parmValue[mapFields.createEnd]"
                  :width="'134px'"
                  :size="searchSize"
                  @timeReturned="handleTime"
                />
              </el-col>

              <el-col :span="4" style="margin-right:10px">
                <el-input size="mini" v-model="parmValue[mapFields.demandOrderNo]" placeholder="需求订单编号"  @change="
                  pageInfo.curr = 1;
                  parmValue.page = 1;
                  searchList();
                "/>
              </el-col>

              <el-col :span="4" style="width: 130px">
                <el-select
                  :size="searchSize"
                  v-model="parmValue[mapFields.status]"
                  clearable
                  placeholder="付款状态"
                  @change="
                    pageInfo.curr = 1;
                    parmValue.page = 1;
                    searchList();
                  "
                >
                  <el-option
                    v-for="item in statusList"
                    :key="item.id"
                    :label="item.label"
                    :value="item.id"
                  >
                  </el-option>
                </el-select>
              </el-col>

              <el-col :span="3" style="width: 66px; float: right">
                <el-button
                  :size="searchSize"
                  type="primary"
                  style="float: right; margin-left: 5px"
                  @click="searchList"
                >
                  刷新
                </el-button>
              </el-col>
              <el-col :span="4" class="fr" style="width: 66px">
                <el-button
                  type="warning"
                  class="fr"
                  :size="searchSize"
                  @click="restSearch"
                >
                  重置
                </el-button>
              </el-col>
            </el-row>

            <el-row style="margin-top:10px">
              <el-col :span="4" style="margin-right:10px">
                <el-input size="mini" v-model="parmValue[mapFields.paymentApplyNo]" placeholder="付款申请编号"  @change="
                  pageInfo.curr = 1;
                  parmValue.page = 1;
                  searchList();
                "/>
              </el-col>
                <el-col :span="4" style="margin-left:10px">
                   <search-customer style="width:100%" size="mini" placeholder="需求公司" :value.sync="parmValue[mapFields.demandCompany]" @change="
                     pageInfo.curr = 1;
                     parmValue.page = 1;
                     searchList();
                     " 
                   />
                 </el-col>

              <el-col :span="3" style="width: 66px; float: right">
                <el-button
                  :size="searchSize"
                  type="primary"
                  style="float: right; margin-left: 5px"
                  @click="handleApproval"
                >
                  批量审核付款申请
                </el-button>
              </el-col>
            </el-row>
          </div>
        </template>
        <template #status="{ scope }">
          <el-tag
            :size="tablebtnSize"
            :type="
              (statusList.find((item) => item.id == scope.row.status) || {})
                .type || ''
            "
            v-text="
              (statusList.find((item) => item.id == scope.row.status) || {})
                .label || '--'
            "
          ></el-tag>
        </template>
        <template #operation="{ scope }">
          <el-tooltip
            effect="dark"
            content="详情"
            placement="top"
          >
            <i class="el-icon-view tb-icon" @click="getRouter('paymentApplyDetail', scope.row.id )" />
          </el-tooltip>
        </template>
      </ex-table>
    </div>
  </div>
</template>
<script>
import mixinPage from "@/mixins/elPaginationHandle";
import resToken from "@/mixins/resToken";
import asyncRequest from "@/apis/service/customerService/paymentApply";
import companyHelper from "@/mixins/companyHelper"
import { listCol, statusList } from "./columns";
import { mapGetters } from "vuex";

const mapFields = {
  createStart:'create_start', //创建开始时间
  createEnd:'create_end',  //创建结束时间
  demandOrderNo:'reqCode', //需求订单编号
  status:'status', //付款状
  // supplier:'customer_id', //供应商公司
  paymentApplyNo:'DzNo', //付款申请编号
  demandCompany:'customer_id' //需求企业
}

export default {
  name: "bargainList",
  mixins: [mixinPage, resToken, companyHelper],
  computed: {
    ...mapGetters(["tablebtnSize", "searchSize", "size"]),
    powers() {
      const tran =
        this.$store.getters.btnList.find(
          (item) => item.menu_route == "bargainList"
        ) || {};
      const { action } = tran ?? {};
      return action ?? [];
    },
  },
  data() {
    return {
      select: "1",
      s_input: "",
      mapFields,
      statusList,
      sitem: null,
      selected:[],
      loading: false,
      showModel: false,
      isDetail: false,
      modelId: 0,
      parmValue: {
        supplierName: "",
        customer_code: "",
        bidsNo: "", // 反馈编号
        infoNo: "", // 竞价单编号
        status: "", // 状态
        bargainNo: "", //议价编号
        status: "", //售后申请单处理状态
        start: "",
        end: "",
        page: 1, // 页码
        size: 15, // 每页显示条数
        company_name:"",
      },
      // 表格 - 数据
      tableData: [],
      // 表格 - 参数
      table: {
        stripe: true,
        border: true,
        _defaultHeader_: ["setcol"],
      },
      // 表格 - 分页
      pageInfo: {
        size: 15,
        curr: 1,
        total: 0,
      },
      // 表格 - 列参数
      columns: listCol,

      resultValue: "", //处理结果
    };
  },
  mounted() {
    const { back } = this.$route.query;
    if (back) {
      this.parmValue = JSON.parse(back);
      
      const { page, size }=this.parmValue;
      
      this.pageInfo= {
        size: size,
        curr: page,
        total: 0,
      }
      //多选条件
    this.select = this.parmValue.select;
    // this.sselect = this.parmValue.sselect;
    this.s_input = this.parmValue.s_input

    }else{
       this.select = "1";
      //  this.sselect = "创建时间"
    }
    this.searchList();
  },
  methods: {
    getRouter(toRouter, queryId){
      if (toRouter && queryId) {
        let model = {
          id: queryId,
          type: 'view',
        };

         let routerModel = {
          options: JSON.parse(JSON.stringify(this.parmValue)),
          router: this.$route.path,
        };
        model.preModel = JSON.stringify(routerModel);
        
        this.routeGoto(toRouter, model);
      } else {
        this.$message.warning("暂未找到相关流程！");
      }
    },
    restSearch() {
      this.customerCode = [];
      this.select = "1";
      this.s_input = "";
      this.parmValue = {
        bidsNo: "", // 反馈编号
        infoNo: "", // 竞价单编号
        bargainNo: "", //议价编号
        status: "", // 状态
        start: "",
        end: "",
        page: 1, // 页码
        size: 15, // 每页显示条数
        company_name:"",
      };
      // 表格 - 分页
      this.pageInfo = {
        size: 15,
        curr: 1,
        total: 0,
      };
      this.searchList();
    },

    openModal(id, isDetail, sitem) {
      this.showModel = true;
      this.modelId = id;
      this.isDetail = isDetail;
      this.sitem = sitem;
    },
    async deleteById(id, status) {
      await this.$confirm("确定要删除？", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      }).then(async () => {
          const model = {
            id: id,
            status: status + '' === "1" ? "0" : "1",
          };
          const res = await asyncRequest.status(model);
          if (res && res.code === 0) {
            this.$notify.success({
              title: "删除成功",
              message: "",
            });
            this.searchList();
          } else if (res && res.code >= 100 && res.code <= 104) {
            await this.logout();
          } else {
            this.$message.warning(res.message);
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
    handleSelection(list){
      this.selected = list
    },
    handleApproval(){
      console.log(this.selected)
      if(this.selected.length === 0){
        this.$message.warning('请选择至少一个状态为"待供应商确认"的付款申请')
        return
      }

      const isOK = this.selected.every(({status}) => Number(status) === 2)

      if(!isOK){
        this.$message.warning('请选择状态为"待供应商确认"的付款申请')
        return
      }

      this.$confirm("是否确认付款？",{
        title:'供应商确认付款',
        type:'warning'
      }).then(async () => {
        const { code } = await asyncRequest.batch({
          id: this.selected.map(({id}) => id),
          status:3
        })
        if(code !== 1) return
        this.searchList()
      })
    },
    // 列表搜索
    async searchList() {
      if (
        (this.parmValue[mapFields.createStart] !== "" && this.parmValue[mapFields.createEnd] === "") ||
        (this.parmValue[mapFields.createStart] === "" && this.parmValue[mapFields.createEnd] !== "")
      ) {
        this.$message.warning("时间区间不完整！");
        return;
      }

      this.loading = true;
      
      const res = await asyncRequest.list({
        ...this.parmValue
      });

      if (res && res.code === 1 && res.data) {
        this.tableData = res.data.list;
        this.pageInfo.total = Number(res.data.count);
      } else {
        this.tableData = [];
        this.pageInfo.total = 0;
      }
      this.loading = false;
    },

    async statusConfirm(id, status) {
      let str = status + '' === "1" ? "禁用" : "启用";
      await this.$confirm("确定要改为" + str + "?", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          this.loading = true;
          const model = {
            id: id,
            status: status + '' === "1" ? "0" : "1",
          };
          const res = await asyncRequest.status(model);
          if (res && res.code === 0) {
            this.loading = false;
            this.$notify.success({
              title: "状态修改成功！",
              message: "",
            });
            await this.searchList();
          } else if (res && res.code >= 100 && res.code <= 104) {
            await this.logout();
          } else {
            this.$message.warning(res.message);
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
    // 时间选择事件
    async handleTime(e) {
      if (e.startTime !== "") {
        this.parmValue[mapFields.createStart] = e.startTime;
      } else {
        this.parmValue[mapFields.createStart] = "";
      }
      if (e.endTime !== "") {
        this.parmValue[mapFields.createEnd] = e.endTime;
      } else {
        this.parmValue[mapFields.createEnd] = "";
      }
      if (this.parmValue[mapFields.createStart] !== "" && this.parmValue[mapFields.createEnd] !== "") {
        this.pageInfo.curr = 1;
        this.parmValue.page = 1;
        await this.searchList();
      }
    },
    async customerChange(e) {
      const { code } = e;
      this.parmValue.customer_code = code ? [code] : [];
      this.parmValue.supplierName = e.label;
      this.pageInfo.curr = 1;
      this.parmValue.page = 1;
      await this.searchList();
    },
  },
};
</script>
   <style lang="scss" scoped>
.bargainList {
}
</style>
   